CON
''==============================================================================
'' Wrapper object for the Toggle plugin. From Spin, this wrapper is not
'' strictly necessary, and the wrapper methods could be included in the
'' plugin object itself - however, by doing it this way, the toggle plugin
'' contains only the code necessary to make the plugin useful from ANY
'' high level language, with the code necessary to use the plugin from
'' Spin contained here
''==============================================================================

OBJ
   Common : "Common.Spin"
   Toggle : "Toggle_Plugin.spin"

PUB RegisterServices | lock
   ' we must register the services before we can call them. Note the use
   ' of LOCKNEW to retrieve a lock to use to prevent contention if this
   ' plugin is used from multiple threads.
   lock := LOCKNEW
   Common.RegisterServiceType(1, lock, Toggle#TOGGLE, Toggle#GET_BUFFER)
   Common.RegisterServiceType(2, lock, Toggle#TOGGLE, Toggle#SET_RATE)
   Common.RegisterServiceType(3, lock, Toggle#TOGGLE, Toggle#START_TOGGLE)
   Common.RegisterServiceType(4, lock, Toggle#TOGGLE, Toggle#STOP_TOGGLE)

PUB Get_Buffer : buffer
  return Common.ShortServiceRequest(1, 0)

PUB Set_Rate (Rate)
  ' note that this is a LONG request !!!
  Common.LongServiceRequest(2, Rate)

PUB Start_Toggle
  Common.ShortServiceRequest(3, 0)

PUB Stop_Toggle
  Common.ShortServiceRequest(4, 0)
